﻿#pragma once
#include <stdio.h>									//C-File-Handling
#include <math.h>

class Ele{
public:
    Ele();
    Ele(double d);
    void* data;                      //mit Knoten verbundene Daten
    Ele *l, *r, *next;               //Blattstruktur
    int m;							 //Markierung
    double d;
};
class FibHeap{
	public:
        FibHeap();
        ~FibHeap();
        void* ins(float d, void* data);
        void* getmin();
        void* extmin();
        double Extmin();
        void* del(Ele* e);
        int size();
	private:
		void clean();
        Ele* m;
		long int n;
};
