﻿#include "UndoRedo.h"

UndoRedo::UndoRedo(){
    l = new undoredolist;
	l->next = NULL;
	l->prev = l;
    l->element = new Track();
	c = l;
	keepbeforeundo = 1;
}
UndoRedo::~UndoRedo(){
	del_list(l);
}
void UndoRedo::add(Track* element){
	if(element->notNULL()){
		del_list(c->next);
        c->next = new undoredolist;
		c->next->prev = c;
		c = c->next;
		c->next = NULL;
        c->element = new Track(element);
		l->prev = c;
        keepbeforeundo = 1;
	}
}
Track* UndoRedo::undo(Track* element){
    if(keepbeforeundo){
        /*bevor etwas rueckgaengig gemacht wird sollte der aktuellste Zustand
        eventuell gesichert werden*/
        add(element);
        keepbeforeundo = 0;
    }
    else
        /*oder eben geloescht*/
        element->~Track();
    if(c != l){
		c = c->prev;
        return new Track(c->element);
	}
	else
        return new Track(l->element);
}
Track* UndoRedo::redo(){
	if(c->next != NULL){
		c = c->next;
        return new Track(c->element);
	}
	else
        return new Track(c->element);
}
void UndoRedo::del_list(undoredolist* t){
	undoredolist* tt;
	while(t != NULL){
		tt = t;
		t = t->next;
        tt->element->~Track();
        delete tt;
	}
}
